//+------------------------------------------------------------------+
//|                                        e-FXOE-SHIChannel_ZZZ.mq4 |
//|                                      Copyright  2011, ZZZEROXXX |
//|                                       http://www.metaquotes.net/ |
//+------------------------------------------------------------------+
#define MAGICMA  1565452258

extern double Lots               = 0.1;
extern string SLTPStr            = "=== StopLoss && Takeprofit, ignore if 0 ===";
extern double StopLoss           = 0;
extern double TakeProfit         = 0;

extern string MM                 = "=== Money management params ===";
extern bool UseMM                = false;
extern double MaximumRisk        = 0.02;
extern double DecreaseFactor     = 3;
extern string IndParams1         = "=== FXOE_SHIChannel params ===";
extern bool   AlertSlopeChange   = false;
extern bool   AlertChannelBreak  = false;
extern int    SHIBars            = 240; 
extern int    BarsForFract       = 0;
extern bool   DebugLogger        = false;
extern string SignalParamsStr1   = "=== Signal criteries ===";
extern bool SignalByCandleClose = true;
extern double BreakevenPtsFilter = 250;
extern bool ChannelSlopeFilter = false;
extern bool SlopeFilter_DirectUndirect = true;



double upL=0;
double downL=0;
double medianL=0;
double up5L=0;



bool buycond=false;
bool sellcond=false;

bool closebuycond=false;
bool closesellcond=false;

double TP=0;
double SL=0;

int lastOP=0;


bool EnableSells()
{

if (ChannelSlopeFilter==false)
{
 if (BreakevenPtsFilter==0) 
 {
  if (SignalByCandleClose==true)
    if (Close[1]<downL) return(true); else return(false);
  else
    if (Bid<downL) return(true); else return(false); 
 }
 if (BreakevenPtsFilter!=0) 
 {
  if (SignalByCandleClose==true)
    if (Close[1]<downL && ((downL-Close[1])>=(BreakevenPtsFilter*Point))) {return(true);} else return(false);
  else
    if (Bid<downL && ((downL-Low[1])>=(BreakevenPtsFilter*Point))) return(true); else return(false); 
 }
}

if (ChannelSlopeFilter==true)
{

if (SlopeFilter_DirectUndirect==true)
{
  if (BreakevenPtsFilter==0) 
  {
   if (SignalByCandleClose==true)
     if (Close[1]<downL && upL<up5L) return(true); else return(false);
   else
     if (Bid<downL  && upL<up5L) return(true); else return(false); 
  }
  if (BreakevenPtsFilter!=0) 
  {
   if (SignalByCandleClose==true)
     if (Close[1]<downL && upL<up5L && ((downL-Close[1])>=(BreakevenPtsFilter*Point))) {return(true);} else return(false);
   else
     if (Bid<downL  && upL<up5L && ((downL-Low[1])>=(BreakevenPtsFilter*Point))) return(true); else return(false); 
  }
} 

if (SlopeFilter_DirectUndirect==false)
{
  if (BreakevenPtsFilter==0) 
  {
   if (SignalByCandleClose==true)
     if (Close[1]<downL && upL>up5L) return(true); else return(false);
   else
     if (Bid<downL  && upL>up5L) return(true); else return(false); 
  }
  if (BreakevenPtsFilter!=0) 
  {
   if (SignalByCandleClose==true)
     if (Close[1]<downL && upL>up5L && ((downL-Close[1])>=(BreakevenPtsFilter*Point))) {return(true);} else return(false);
   else
     if (Bid<downL  && upL>up5L && ((downL-Low[1])>=(BreakevenPtsFilter*Point))) return(true); else return(false); 
  }
} 
 
}
}


bool EnableBuys()
{
if (ChannelSlopeFilter==false)
{

 if (BreakevenPtsFilter==0) 
 {
  if (SignalByCandleClose==true)
    if (Close[1]>upL) return(true); else return(false);
  else
    if (Ask>upL) return(true); else return(false);
 }
 if (BreakevenPtsFilter!=0) 
 {
  if (SignalByCandleClose==true)
    if (Close[1]>upL && ((Close[1]-upL)>=(BreakevenPtsFilter*Point))) { return(true);} else return(false);
  else
    if (Ask>upL && ((High[1]-upL)>=(BreakevenPtsFilter*Point))) return(true); else return(false);
 }
}

if (ChannelSlopeFilter==true)
{
if (SlopeFilter_DirectUndirect==true)
{
  if (BreakevenPtsFilter==0) 
  {
   if (SignalByCandleClose==true)
     if (Close[1]>upL && upL>up5L) return(true); else return(false);
   else
     if (Ask>upL && upL>up5L) return(true); else return(false);
  }
  if (BreakevenPtsFilter!=0) 
  {
   if (SignalByCandleClose==true)
     if (Close[1]>upL && upL>up5L && ((Close[1]-upL)>=(BreakevenPtsFilter*Point))) { return(true);} else return(false);
   else
     if (Ask>upL && upL>up5L && ((High[1]-upL)>=(BreakevenPtsFilter*Point))) return(true); else return(false);
  }
}

if (SlopeFilter_DirectUndirect==false)
{
  if (BreakevenPtsFilter==0) 
  {
   if (SignalByCandleClose==true)
     if (Close[1]>upL && upL<up5L) return(true); else return(false);
   else
     if (Ask>upL && upL<up5L) return(true); else return(false);
  }
  if (BreakevenPtsFilter!=0) 
  {
   if (SignalByCandleClose==true)
     if (Close[1]>upL && upL<up5L && ((Close[1]-upL)>=(BreakevenPtsFilter*Point))) { return(true);} else return(false);
   else
     if (Ask>upL && upL<up5L && ((High[1]-upL)>=(BreakevenPtsFilter*Point))) return(true); else return(false);
  }
}

}

}


void Calculate()
{
upL=iCustom(Symbol(),0,"FXOE-SHIChannel",AlertSlopeChange,AlertChannelBreak,SHIBars,BarsForFract,DebugLogger,0,1);
medianL=iCustom(Symbol(),0,"FXOE-SHIChannel",AlertSlopeChange,AlertChannelBreak,SHIBars,BarsForFract,DebugLogger,1,1);
downL=iCustom(Symbol(),0,"FXOE-SHIChannel",AlertSlopeChange,AlertChannelBreak,SHIBars,BarsForFract,DebugLogger,2,1);
up5L=iCustom(Symbol(),0,"FXOE-SHIChannel",AlertSlopeChange,AlertChannelBreak,SHIBars,BarsForFract,DebugLogger,0,5);

//==============================  ================================================
if (EnableBuys()==true && (lastOP==0 || lastOP==-1)) {buycond=true; sellcond=false;Print(Close[1]-upL);} 
if (EnableSells()==true && (lastOP==0 || lastOP==1)) {buycond=false; sellcond=true;Print(downL-Close[1]);}

if (EnableBuys()==true) {closesellcond=true; closebuycond=false;}
if (EnableSells()==true) {closebuycond=true; closesellcond=false;}

}


int CalculateCurrentOrders(string symbol)
  {
   int buys=0,sells=0;
//----
   for(int i=0;i<OrdersTotal();i++)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false) break;
      if(OrderSymbol()==Symbol() && OrderMagicNumber()==MAGICMA)
        {
         if(OrderType()==OP_BUY)  buys++;
         if(OrderType()==OP_SELL) sells++;
        }
     }
   if(buys>0) return(buys);
   else       return(-sells);
  }

double LotsOptimized()
  {
   double lot=Lots;
   int    orders=HistoryTotal();     // history orders total
   int    losses=0;                  // number of losses orders without a break
//---- select lot size
   lot=NormalizeDouble(AccountFreeMargin()*MaximumRisk/1000.0,1);
//---- calcuulate number of losses orders without a break
   if(DecreaseFactor>0)
     {
      for(int i=orders-1;i>=0;i--)
        {
         if(OrderSelect(i,SELECT_BY_POS,MODE_HISTORY)==false) { Print("Error in history!"); break; }
         if(OrderSymbol()!=Symbol() || OrderType()>OP_SELL) continue;
         //----
         if(OrderProfit()>0) break;
         if(OrderProfit()<0) losses++;
        }
      if(losses>1) lot=NormalizeDouble(lot-lot*losses/DecreaseFactor,1);
     }
//---- return lot size
   if(lot<0.1) lot=0.1;
   if (UseMM==true) return(lot); else return(Lots);
  }



void CheckForOpen()
  {
   int    res;
//---- sell conditions
   double stoplevel=MarketInfo(Symbol(),14);
   if(sellcond==true)  
     {
      
       if (StopLoss!=0) SL=Bid+(NormalizeDouble(Point*StopLoss,Digits)); else SL=0;
       if (TakeProfit!=0) TP=Bid-(NormalizeDouble(Point*TakeProfit,Digits)); else TP=0;
      
      res=OrderSend(Symbol(),OP_SELL,LotsOptimized(),Bid,3,SL,TP,"",MAGICMA,0,Red);
      lastOP=-1;
      sellcond=false;
      return;
     }
//---- buy conditions
   if(buycond==true)  
     {
     
       if (StopLoss!=0) SL=Ask-(NormalizeDouble(Point*StopLoss,Digits)); else SL=0;
       if (TakeProfit!=0) TP=Ask+(NormalizeDouble(Point*TakeProfit,Digits)); else TP=0;
      
      res=OrderSend(Symbol(),OP_BUY,LotsOptimized(),Ask,3,SL,TP,"",MAGICMA,0,Blue);
      lastOP=1;
      buycond=false;
      return;
     }
//----
  }


void CheckForClose()
  {
   for(int i=0;i<OrdersTotal();i++)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false)        break;
      if(OrderMagicNumber()!=MAGICMA || OrderSymbol()!=Symbol()) continue;
      //---- check order type 
      if(OrderType()==OP_BUY)
        {
         if(closebuycond==true) {OrderClose(OrderTicket(),OrderLots(),Bid,3,White);
         closebuycond=false; buycond=false; lastOP=0;}
         break;
        }
      if(OrderType()==OP_SELL)
        {
         if(closesellcond==true) {OrderClose(OrderTicket(),OrderLots(),Ask,3,White);
         closesellcond=false; sellcond=false; lastOP=0;}
         break;
        }
     }

}

void start()
  {
   if(Bars<100 || IsTradeAllowed()==false) return;
   Calculate();
   
   if(CalculateCurrentOrders(Symbol())==0) CheckForOpen();
   else 
   {
   CheckForClose();
   }
   Print(upL + "==" +up5L);
   
//----
  }
//+------------------------------------------------------------------+